package com.bergerkiller.bukkit.nolaggtnt;

import net.minecraft.server.Entity;
import net.minecraft.server.EntityTNTPrimed;

import org.bukkit.craftbukkit.entity.CraftEntity;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityExplodeEvent;
import org.bukkit.event.entity.ExplosionPrimeEvent;

public class NLTListener implements Listener {
	
	@EventHandler(priority = EventPriority.MONITOR)
	public void onExplosionPrime(ExplosionPrimeEvent event) {
		if (event.isCancelled()) return;
		if (event.getEntity() == null) return;
		Entity entity = ((CraftEntity) event.getEntity()).getHandle();
		if (entity == null) return;
		if (entity instanceof EntityTNTPrimed) {
			event.setCancelled(true);
			//do stuff	
			CustomExplosion explosion = new CustomExplosion(entity.world, entity, entity.locX, entity.locY, entity.locZ, event.getRadius(), event.getFire());
	        explosion.doAll();
		}
	}
	
	@EventHandler(priority = EventPriority.MONITOR)
	public void onEntityExplode(EntityExplodeEvent event) {
		if (!event.isCancelled()) {
			if (TnTHandler.createExplosion(event)) {
				//I know, we monitor, but the end result is the same anyway!
				event.setCancelled(true);
			}
		}
	}
	
}
